Package weka.filters.unsupervised.attribute

# Class AddCluster

java.lang.Object
weka.filters.Filter
weka.filters.unsupervised.attribute.AddCluster

All Implemented Interfaces:
  `Serializable`, `CapabilitiesHandler`, `CapabilitiesIgnorer`, `CommandlineRunnable`, `OptionHandler`, `RevisionHandler`, `WeightedAttributesHandler`, `WeightedInstancesHandler`, `UnsupervisedFilter`

public class AddCluster extends Filter implements UnsupervisedFilter, OptionHandler, WeightedAttributesHandler, WeightedInstancesHandler
A filter that adds a new nominal attribute representing the cluster assigned to each instance by the specified clustering algorithm.
Either the clustering algorithm gets built with the first batch of data or one specifies are serialized clusterer model file to use instead.

Valid options are:

     -W <clusterer specification>
      Full class name of clusterer to use, followed
      by scheme options. eg:
       "weka.clusterers.SimpleKMeans -N 3"
      (default: weka.clusterers.SimpleKMeans)

     -serialized <file>
      Instead of building a clusterer on the data, one can also provide
      a serialized model and use that for adding the clusters.

     -I <att1,att2-att4,...>
      The range of attributes the clusterer should ignore.

Version:
  $Revision: 15204 $
Author:
  Richard Kirkby (rkirkby@cs.waikato.ac.nz), FracPete (fracpete at waikato dot ac dot nz)
See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AddCluster()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `batchFinished()`
  Signify that this batch of input to the filter is finished.
  `String`
  `clustererTipText()`
  Returns the tip text for this property.
  `Capabilities`
  `getCapabilities()`
  Returns the Capabilities of this filter.
  `Capabilities`
  `getCapabilities(Instances data)`
  Returns the Capabilities of this filter, makes sure that the class is never set (for the clusterer).
  `Clusterer`
  `getClusterer()`
  Gets the clusterer used by the filter.
  `String`
  `getIgnoredAttributeIndices()`
  Gets ranges of attributes to be ignored.
  `String[]`
  `getOptions()`
  Gets the current settings of the filter.
  `String`
  `getRevision()`
  Returns the revision string.
  `File`
  `getSerializedClustererFile()`
  Gets the file pointing to a serialized, built clusterer.
  `String`
  `globalInfo()`
  Returns a string describing this filter.
  `String`
  `ignoredAttributeIndicesTipText()`
  Returns the tip text for this property.
  `boolean`
  `input(Instance instance)`
  Input an instance for filtering.
  `Enumeration<Option>`
  `listOptions()`
  Returns an enumeration describing the available options.
  `static void`
  `main(String[] argv)`
  Main method for testing this class.
  `String`
  `serializedClustererFileTipText()`
  Returns the tip text for this property.
  `void`
  `setClusterer(Clusterer clusterer)`
  Sets the clusterer to assign clusters with.
  `void`
  `setIgnoredAttributeIndices(String rangeList)`
  Sets the ranges of attributes to be ignored.
  `boolean`
  `setInputFormat(Instances instanceInfo)`
  Sets the format of the input instances.
  `void`
  `setOptions(String[] options)`
  Parses a given list of options.
  `void`
  `setSerializedClustererFile(File value)`
  Sets the file pointing to a serialized, built clusterer.

  ### Methods inherited from class weka.filters.Filter

  `batchFilterFile, debugTipText, doNotCheckCapabilitiesTipText, filterFile, getCopyOfInputFormat, getDebug, getDoNotCheckCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, mayRemoveInstanceAfterFirstBatchDone, numPendingOutput, output, outputPeek, postExecution, preExecution, run, runFilter, setDebug, setDoNotCheckCapabilities, toString, useFilter, wekaStaticWrapper`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### AddCluster

    public AddCluster()

- ## Method Details

  - ### getCapabilities

    public Capabilities getCapabilities(Instances data)
    Returns the Capabilities of this filter, makes sure that the class is never set (for the clusterer).
    Overrides:
      `getCapabilities` in class `Filter`
    Parameters:
      `data` - the data to use for customization
    Returns:
      the capabilities of this object, based on the data
    See Also:
      - `getCapabilities()`

  - ### getCapabilities

    public Capabilities getCapabilities()
    Returns the Capabilities of this filter.
    Specified by:
      `getCapabilities` in interface `CapabilitiesHandler`
    Overrides:
      `getCapabilities` in class `Filter`
    Returns:
      the capabilities of this object
    See Also:
      - `Capabilities`

  - ### setInputFormat

    public boolean setInputFormat(Instances instanceInfo) throws Exception
    Sets the format of the input instances.
    Overrides:
      `setInputFormat` in class `Filter`
    Parameters:
      `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
    Returns:
      true if the outputFormat may be collected immediately
    Throws:
      `Exception` - if the inputFormat can't be set successfully

  - ### batchFinished

    public boolean batchFinished() throws Exception
    Signify that this batch of input to the filter is finished.
    Overrides:
      `batchFinished` in class `Filter`
    Returns:
      true if there are instances pending output
    Throws:
      `IllegalStateException` - if no input structure has been defined
      `NullPointerException` - if no input structure has been defined,
      `Exception` - if there was a problem finishing the batch.

  - ### input

    public boolean input(Instance instance) throws Exception
    Input an instance for filtering. Ordinarily the instance is processed and made available for output immediately. Some filters require all instances be read before producing output.
    Overrides:
      `input` in class `Filter`
    Parameters:
      `instance` - the input instance
    Returns:
      true if the filtered instance may now be collected with output().
    Throws:
      `IllegalStateException` - if no input format has been defined.
      `NullPointerException` - if the input format has not been defined.
      `Exception` - if the input instance was not of the correct format or if there was a problem with the filtering.

  - ### listOptions

    public Enumeration<Option> listOptions()
    Returns an enumeration describing the available options.
    Specified by:
      `listOptions` in interface `OptionHandler`
    Overrides:
      `listOptions` in class `Filter`
    Returns:
      an enumeration of all the available options.

  - ### setOptions

    public void setOptions(String[] options) throws Exception
    Parses a given list of options.

    Valid options are:

         -W <clusterer specification>
          Full class name of clusterer to use, followed
          by scheme options. eg:
           "weka.clusterers.SimpleKMeans -N 3"
          (default: weka.clusterers.SimpleKMeans)

         -serialized <file>
          Instead of building a clusterer on the data, one can also provide
          a serialized model and use that for adding the clusters.

         -I <att1,att2-att4,...>
          The range of attributes the clusterer should ignore.

    Specified by:
      `setOptions` in interface `OptionHandler`
    Overrides:
      `setOptions` in class `Filter`
    Parameters:
      `options` - the list of options as an array of strings
    Throws:
      `Exception` - if an option is not supported

  - ### getOptions

    public String[] getOptions()
    Gets the current settings of the filter.
    Specified by:
      `getOptions` in interface `OptionHandler`
    Overrides:
      `getOptions` in class `Filter`
    Returns:
      an array of strings suitable for passing to setOptions

  - ### globalInfo

    public String globalInfo()
    Returns a string describing this filter.
    Returns:
      a description of the filter suitable for displaying in the explorer/experimenter gui

  - ### clustererTipText

    public String clustererTipText()
    Returns the tip text for this property.
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### setClusterer

    public void setClusterer(Clusterer clusterer)
    Sets the clusterer to assign clusters with.
    Parameters:
      `clusterer` - The clusterer to be used (with its options set).

  - ### getClusterer

    public Clusterer getClusterer()
    Gets the clusterer used by the filter.
    Returns:
      The clusterer being used.

  - ### ignoredAttributeIndicesTipText

    public String ignoredAttributeIndicesTipText()
    Returns the tip text for this property.
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### getIgnoredAttributeIndices

    public String getIgnoredAttributeIndices()
    Gets ranges of attributes to be ignored.
    Returns:
      a string containing a comma-separated list of ranges

  - ### setIgnoredAttributeIndices

    public void setIgnoredAttributeIndices(String rangeList)
    Sets the ranges of attributes to be ignored. If provided string is null, no attributes will be ignored.
    Parameters:
      `rangeList` - a string representing the list of attributes. eg: first-3,5,6-last
    Throws:
      `IllegalArgumentException` - if an invalid range list is supplied

  - ### getSerializedClustererFile

    public File getSerializedClustererFile()
    Gets the file pointing to a serialized, built clusterer. If it is null or pointing to a directory it will not be used.
    Returns:
      the file the serialized, built clusterer is located in

  - ### setSerializedClustererFile

    public void setSerializedClustererFile(File value)
    Sets the file pointing to a serialized, built clusterer. If the argument is null, doesn't exist or pointing to a directory, then the value is ignored.
    Parameters:
      `value` - the file pointing to the serialized, built clusterer

  - ### serializedClustererFileTipText

    public String serializedClustererFileTipText()
    Returns the tip text for this property.
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### getRevision

    public String getRevision()
    Returns the revision string.
    Specified by:
      `getRevision` in interface `RevisionHandler`
    Overrides:
      `getRevision` in class `Filter`
    Returns:
      the revision

  - ### main

    public static void main(String[] argv)
    Main method for testing this class.
    Parameters:
      `argv` - should contain arguments to the filter: use -h for help